// Control context menu
function objDwContextMenu(pref)
{
	///////////// Private variables /////////////
	var preference = pref;
	var bundle;

	///////////// Public Methods /////////////
	this.init = function() {
		dwUtil.debug("objDwContextMenu.init()");
		bundle = document.getElementById("downloadwithbundle");
		document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",dwContextMenu.initMenu,false);
	}

	this.commanded = function(e,menu) {
		dwUtil.debug("objDwContextMenu.commanded(" + e + ","+ menu +")");
		var t = e.target;
		if (t.id != "downloadwith-invalide-url") {
			// load url
			var baseurl = t.getAttribute("url");
			// Execute application
			var application = preference.getApplication(t.id);
			var label = application[preference.LABEL];
			var command = application[preference.COMMAND];
			var arguments = application[preference.ARGS];
      
			// replace URL 
			var strArgs = arguments.replace(/\[URL\]/, baseurl);
			dwUtil.execCommand(command,strArgs);
		}
		if(e.button==1) menu.hidePopup();  
	}

	this.commandedfast = function() {
		dwUtil.debug("objDwContextMenu.fast()");
		var url = this.getLink();
		if(!url) return;
		// Execute application
		var application = preference.getFirstApplication();
		var command = application[preference.COMMAND];
		var arguments = application[preference.ARGS];      
		// replace URL 
		var strArgs = arguments.replace(/\[URL\]/, url);
		dwUtil.execCommand(command,strArgs);
	}

	this.initMenu = function() {
		dwUtil.debug("objDwContextMenu.initmenu()");
		var cm = gContextMenu;
		var submenu = document.getElementById("context-downloadwith");
		var fastmenu = document.getElementById("downloadwith-fastmenu");
		var allmenu = document.getElementById("context-downloadwith-allmenu");
		if (cm.onLink) {
			allmenu.hidden = true;
			if (!preference.contextMenuEnable() || preference.getApplicationArray().length == 0) {
				submenu.hidden = true;
				fastmenu.hidden = true;
			} else if (preference.getApplicationArray().length == 1 && !preference.showContextMenuURL()) {
				submenu.hidden = true;
				fastmenu.hidden = false;
				fastmenu.label = fastmenu.getAttribute("prelabel") + " " + preference.getFirstApplication()[preference.LABEL];
			} else {
				fastmenu.hidden = true;
				submenu.hidden = false;
			}
		} else {
				allmenu.hidden = false;
				submenu.hidden = true;
				fastmenu.hidden = true;			
		}
	}

	this.clearMenu = function(menu) {
		dwUtil.debug("objDwContextMenu.clearMenu(" + menu + ")");
		while(menu.hasChildNodes()) menu.removeChild(menu.lastChild);
	}

	this.getLink = function() {
		dwUtil.debug("objDwContextMenu.getLink()");
		var elem = document.popupNode;
		while(elem) {
			if(elem instanceof Components.interfaces.nsIDOMHTMLAnchorElement && elem.href)
				return elem.href;
			elem = elem.parentNode;
		}
		return null;
	}

	this.buildMenu = function(menu) {
		dwUtil.debug("objDwContextMenu.buildMenu(" + menu + ")");
		var url = this.getLink();
		if(!url) return;
//		if(/^(ht|f)tp:\/\//.test(url)) {
			for (var application = preference.getFirstApplication();application != null;application = preference.getNextApplication()) {
				if (application[preference.LABEL] != null && application[preference.LABEL] != "" ) this.addItemApplication(menu,url,application[preference.IDENT],application[preference.LABEL]);
			}
//		} else { this.addItemInvalide(menu); }
	}
    
	this.addItemInvalide = function(menu) {
		dwUtil.debug("objDwContextMenu.addItemInvalidate(" + menu + ")");
		var menuitem = document.createElement("menuitem");
		menuitem.setAttribute("label",bundle.getString("invalideURL"));
		menuitem.setAttribute("id","downloadwith-invalide-url");
		menu.appendChild(menuitem);
	}
  
	this.addItemApplication = function(menu,url,id,label) {
		dwUtil.debug("objDwContextMenu.addItemApplication(" + menu + "," + url + "," + id + "," + label + ")");
		var menuitem = document.createElement("menuitem");
		if (preference.showContextMenuURL())  { menuitem.setAttribute("label",label  + " " + url); }
		else {  menuitem.setAttribute("label",label); }
		menuitem.setAttribute("url",url);
		menuitem.setAttribute("id",id);
		menu.appendChild(menuitem);
	}
}